#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_width1 3
#property indicator_color2 Orange
#property indicator_width2 3

extern string note1 = "First Moving Average";
extern int    MA1 =   2;
extern int    MA1Mode = 1; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    MA1Price = 0;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4

extern string note2 = "Second Moving Average";
extern int    MA2 =   50;
extern int    MA2Mode = 1; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    MA2Price = 0;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4

extern string note3 = "Filter Moving Average";
extern int    MA3 =   100;
extern int    MA3Mode = 1; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    MA3Price = 0;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4

extern int ArrowType=4;
extern bool AlertOn = true;

string CurrentCross = "Null";
string LastCross = "Null";

double CrossUp[];
double CrossDown[];
string AlertPrefix, MA1short_name, MA2short_name, MA3short_name;
string GetTimeFrameStr() {
   switch(Period())
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr=Period();
   } 
   return (TimeFrameStr);
   }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if (ArrowType == 0) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 233);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 234);
   }
   else if (ArrowType == 1) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 225);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 226);
   }
   else if (ArrowType == 2) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 241);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 242);
   }
   else if (ArrowType == 3) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 221);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 222);
   }
   else if (ArrowType == 4) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 217);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 218);
   }
   else if (ArrowType == 5) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 228);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 230);
   }
   else if (ArrowType == 6) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 236);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 238);
   }
   else if (ArrowType == 7) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 246);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 248);
   }
   else if (ArrowType == 8) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 67);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 68);
   }
   else if (ArrowType == 9) {
      SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0, 71);
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexArrow(1, 72);
   }

   SetIndexBuffer(0, CrossUp);
   SetIndexBuffer(1, CrossDown);

//---- indicator short name
   switch(MA1Mode)
     {
      case 1 : MA1short_name="EMA";  break;
      case 2 : MA1short_name="SMMA"; break;
      case 3 : MA1short_name="LWMA"; break;
      default :
         MA1Mode=0;
         MA1short_name="SMA";
     }
   
   switch(MA2Mode)
     {
      case 1 : MA2short_name="EMA";  break;
      case 2 : MA2short_name="SMMA"; break;
      case 3 : MA2short_name="LWMA"; break;
      default :
         MA2Mode=0;
         MA2short_name="SMA";
     }
    
   switch(MA3Mode)
     {
      case 1 : MA3short_name="EMA";  break;
      case 2 : MA3short_name="SMMA"; break;
      case 3 : MA3short_name="LWMA"; break;
      default :
         MA3Mode=0;
         MA3short_name="SMA";
     }  

   AlertPrefix=Symbol()+" ("+GetTimeFrameStr()+"):  ";
//----
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
bool NewBar()
{
   static bool startup = true; //if this is the first time through then in
   static datetime lastbar;
   datetime curbar = Time[0];
    
   if(startup)
   {
      lastbar=curbar;
      startup=false;
      //We will know what it was b/c we can only get here from either a valid up/down crossover.
      LastCross=CurrentCross;  //both global and maintained in main for loop.
      return(false);
   }
   else
   {
      if(lastbar!=curbar)
      {
         lastbar=curbar;
         return (true);
      }
      else
      {
         return(false);
      }
   }
}   
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double MA1now, MA1previous, MA1after;
   double MA2now, MA2previous, MA2after;
   double MA3now, MA3previous, MA3after;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
   
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;

      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      MA1now = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i);
      MA1previous = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i+1);
      MA1after = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i-1);

      MA2now = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i);
      MA2previous = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i+1);
      MA2after = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i-1);
      
      MA3now = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i);
      MA3previous = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i+1);
      MA3after = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i-1);
      
      if ((MA1now > MA2now) && (MA1previous < MA2previous) && (MA1after > MA2after)) 
      {
                   CurrentCross="Up"; //we need to understand what the last cross was.  If the lastcross is the same as this cross then ignore it.
                   CrossUp[i] = Low[i] - Range*1.5;
                   if ((NewBar()) && (LastCross=="Down"))
                   {
                   
                     if (AlertOn) {
                      Alert(AlertPrefix+MA1short_name+" ("+MA1+") "+"crosses UP " + MA2short_name+" ("+MA2+")");
                     }   
              	      
              	      LastCross = CurrentCross;
              	    }
      }
      else if ((MA1now < MA2now) && (MA1previous > MA2previous) && (MA1after < MA2after)) 
      {
                   CurrentCross="Down";
                   CrossDown[i] = High[i] + Range*1.5;
                   if ((NewBar()) && (LastCross=="Up"))
                   {
                     if (AlertOn) {
                      Alert(AlertPrefix+MA1short_name+" ("+MA1+") "+"crosses DOWN " + MA2short_name+" ("+MA2+")");
                  //    Alert("CrossDown", " MA1now=",MA1now," MA2now=",MA2now," MA1previous=",MA1previous," MA2previous=",MA2previous," MA1after =", MA1after, " MA2after =", MA2after);
                     }   

              	      LastCross = CurrentCross;            	      
              	    }
      }
   }
   return(0);
}

